﻿/**
* Set Up for Preloading command by Grant Skinner. Aug 12, 2004
* Modified April 20, 2005 to handle Audio
* Visit www.gskinner.com for documentation, updates and more free code.
*
* Notice: All JSFL commands have the ability to damage your files. It is recommended
* that you run these commands on copies of your files. You take all responsibility
* for any problems or damage incurred directly or indirectly from running this command.
*
* You may distribute this code freely, as long as this comment block remains intact.
*/
function setupForPreloading() {
	fl.trace("Setting up for preloading");
	fl.trace("-----------------------------------------------------------");
	var supportedTypes = ["component","movie clip","graphic","button","compiled clip"];
	
	// set up a supported type index for fast look up:
	var supportedTypesIndex = {};
	for (var i=0;i<supportedTypes.length;i++) {
		supportedTypesIndex[supportedTypes[i]] = true;
	}
	
	var dom = fl.getDocumentDOM();
	if (dom == null) { alert("No Open Document"); return; }
	var lib = dom.library;
	var libItems = lib.items;
	
	// create list of items that need updating:
	var updateCount = 0;
	var l = libItems.length;
	for (var i = 0;i<l;i++) {
		var uItem = libItems[i];
		fl.trace("Examining "+(i+1)+" of "+l+": "+uItem.name+" ("+uItem.itemType+")");
		if (supportedTypesIndex[uItem.itemType] == true && uItem.linkageExportForAS) {
			fl.trace("  -- Prepared library item: "+uItem.name);
			uItem.linkageExportInFirstFrame = false;
			// lame attempt to stagger the items as they're added:
			dom.addItem({x:Math.floor(i/25)*20,y:i%25*20},uItem);
			updateCount++;
		} else if (uItem.itemType == "sound" && uItem.linkageExportForAS) {
			// audio items are added to layers of a single clip
			fl.trace("  -- Prepared library item: "+uItem.name);
			if (audioClip == undefined) { 
				var audioClip = addAudioClip("__exportAudio");
				var t = audioClip.timeline;
				dom.addItem({x:0, y:0}, audioClip);
			}
			t.addNewLayer(uItem.name, "normal", true);
			var f = t.layers[0].frames[0];
			f.soundName = uItem.name;
			f.soundSync = "stop";
			uItem.linkageExportInFirstFrame = false;
			updateCount++;
		}
	}
	
	fl.trace("-----------------------------------------------------------");
	fl.trace("Prepared "+updateCount+" of "+l+" library items");
	fl.trace("-----------------------------------------------------------");
}

// Create the audio clip
function addAudioClip(p_name) {
	var lib = fl.getDocumentDOM().library;
	if (lib.itemExists(p_name)) { lib.deleteItem(p_name); }
	lib.addNewItem("movie clip", p_name);
	return lib.items[lib.findItemIndex(p_name)];
}

setupForPreloading();